"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var Svgo = require('svgo');

var reactSvgPlugin = require('./reactSvgPlugin');

var _require = require('@babel/core'),
    transformSync = _require.transformSync;

function optimizeSvg() {
  var svgo = new Svgo({
    plugins: [{
      removeDoctype: true,
      removeComments: true,
      removeTitle: true,
      removeXMLNS: true
    }]
  });
  return function (content) {
    return svgo.optimize(content).then(function (result) {
      return result.data;
    });
  };
}

function transformSvg() {
  return function (content) {
    return transformSync(content, {
      babelrc: false,
      plugins: ['@babel/plugin-syntax-jsx', reactSvgPlugin]
    });
  };
}

module.exports = function (content) {
  if (this.cacheable) {
    this.cacheable(true);
  }

  this.addDependency(this.resourcePath);
  var callback = this.async();

  _promise.default.resolve(String(content)).then(optimizeSvg()).then(transformSvg()).then(function (result) {
    callback(null, result.code);
  }).catch(function (err) {
    callback(err);
  });
};