"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/json/stringify"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/slicedToArray"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var Bundle = require('./Bundle');

var chalk = require('chalk');

var config = require('../../config');

var fs = require('fs');

var path = require('path');

var printStats = require('../../utils/printStats');

var rimraf = require('rimraf');

module.exports =
/*#__PURE__*/
function () {
  function Build() {
    (0, _classCallCheck2.default)(this, Build);
    this.server = {
      bundle: new Bundle({
        config: config.server.webpack
      })
    };
    this.browser = {
      bundle: new Bundle({
        config: config.browser.webpack
      })
    };
  }

  (0, _createClass2.default)(Build, [{
    key: "run",
    value: function run() {
      rimraf.sync(path.resolve(process.cwd(), 'build'));
      rimraf.sync(path.resolve(process.cwd(), 'stats'));

      _promise.default.all([this.server.bundle.build(), this.browser.bundle.build()]).then(function (_ref) {
        var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
            serverStats = _ref2[0],
            browserStats = _ref2[1];

        printStats(true, [serverStats, browserStats]);
        console.log(chalk.green("Application built"));
        var serverIndexPath = path.resolve(process.cwd(), './build/server/index.js');
        var assetsByChunkName = (0, _stringify.default)(browserStats.toJson({
          children: false,
          chunkModules: false,
          chunks: false,
          assets: true,
          hash: false,
          modules: false,
          timings: false,
          version: false
        }).assetsByChunkName);
        fs.writeFileSync(serverIndexPath, "\n        require('dotenv').config();\n        process.env.NODE_ENV = 'production';\n        process.env.PORT = process.env.PORT || 80;\n        process.env.HOST = process.env.HOST || \"http://localhost:\" + process.env.PORT;\n        require('frontful-config');\n        require('frontful-environment/utils/bundle')(".concat(assetsByChunkName, ");\n        var server = require('frontful-environment/utils/server');\n        var requestHandler = require('./server.js');\n        server(requestHandler, {assets: ").concat(config.server.assets.toString(), "});\n      "));
        var statsPath = path.resolve(process.cwd(), './stats');
        var statsBuildPath = path.resolve(process.cwd(), './stats/build');
        if (!fs.existsSync(statsPath)) fs.mkdirSync(statsPath);
        if (!fs.existsSync(statsBuildPath)) fs.mkdirSync(statsBuildPath);
        fs.writeFileSync(path.resolve(statsBuildPath, './server.json'), (0, _stringify.default)(serverStats.toJson('normal')));
        fs.writeFileSync(path.resolve(statsBuildPath, './browser.json'), (0, _stringify.default)(browserStats.toJson('normal')));
      }).catch(function (error) {
        printStats(true, error);
      });
    }
  }]);
  return Build;
}();