"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var commonConfig = require('frontful-common/config');

var webpack = require('webpack');

process.noDeprecation = true;

module.exports =
/*#__PURE__*/
function () {
  function Bundle(options) {
    (0, _classCallCheck2.default)(this, Bundle);
    this.options = options;
    this.options.watch = this.options.watch || {
      aggregateTimeout: 300,
      ignored: new RegExp("(node_modules.*node_modules)|(node_modules(\\\\|\\/)(?!(".concat(commonConfig.packages.join('|'), ")(\\\\|\\/)))"))
    };
    this.compiler = webpack(this.options.config);
    this.compiler.outputFileSystem = this.options.fs || this.compiler.outputFileSystem;
    this.compiled = false;
    this.watcher = null;
  }

  (0, _createClass2.default)(Bundle, [{
    key: "build",
    value: function build() {
      var _this = this;

      return new _promise.default(function (resolve, reject) {
        _this.compiler.run(function (error, stats) {
          if (error || stats.hasErrors()) {
            reject(stats ? stats : error);
          } else {
            resolve(stats);
          }
        });
      });
    }
  }, {
    key: "watch",
    value: function watch(start, end) {
      var _this2 = this;

      return new _promise.default(function (resolve) {
        _this2.compiler.plugin('watch-run', function (compiler, next) {
          start();
          next();
        });

        _this2.compiler.plugin('invalid', function () {
          start();
        });

        _this2.watcher = _this2.compiler.watch(_this2.options.watch, function (error, stats) {
          if (stats.hasErrors()) {
            end(stats);
          } else {
            end(stats);

            if (!_this2.compiled) {
              _this2.compiled = true;
              resolve(stats);
            }
          }
        });
      });
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      if (this.compiled) {
        this.watcher.invalidate(function () {});
      }
    }
  }]);
  return Bundle;
}();