"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var compression = require('compression');

var config = require('../config');

var fileSystem = require('fs');

var mime = require('mime');

var parse = require('url').parse;

var resolve = require('path').resolve;

var compressor = compression();

module.exports = function getAssetHandler(options) {
  options = (0, _extends2.default)({}, options);
  options.fs = options && options.fs || fileSystem;
  return function assetHandler(req, res, next) {
    try {
      var url = parse(req.url);
      var pathPublic = config['browser'].webpack.output.publicPath;
      var path = config['browser'].webpack.output.path;

      if (url.pathname.indexOf(pathPublic) === 0) {
        var filename = resolve(path, url.pathname.replace(pathPublic, ''));
        var content = options.fs.readFileSync(filename);
        compressor(req, res, function () {});
        res.setHeader("Content-Type", mime.getType(filename));
        res.statusCode = 200;
        res.end(content);
      } else {
        next();
      }
    } catch (error) {
      console.log(error);
      next();
    }
  };
};