"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var errorParser = require('./errorParser');

module.exports = function getErrorHandler(options) {
  options = (0, _extends2.default)({
    details: true
  }, options);
  return function errorHandler(error, req, res, next) {
    error = errorParser(error);
    console.log(error.colorful);

    if (!res.headersSent) {
      res.status(500);

      if (options.details) {
        if (req.accepts('html')) {
          res.send("<pre style=\"color: red;\">".concat(error.string, "</pre>"));
        } else if (req.accepts('json')) {
          res.json({
            error: error.details
          });
        } else {
          res.send(error.string);
        }
      } else {
        res.end();
      }
    } else {
      next();
    }
  };
};